// const { showHUD } = require("marginnote");

JSB.require('settingController');
JSB.require('utils');
var browserController = JSB.defineClass('browserController : UIViewController <UIWebViewDelegate>', {
  viewDidLoad: function() {
    self.homePageURL = 'https://m.inftab.com/'
    self.homeImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/home.png`), 2)
    self.gobackImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/goback.png`), 2)
    self.goforwardImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/goforward.png`), 2)
    self.reloadImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/reload.png`), 2)
    self.stopImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/stop.png`), 2)
    self.screenImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/screen.png`), 2)
    self.webappImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/webapp.png`), 2)
    self.QRCodeImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/QRCode.png`), 2)

    self.appInstance = Application.sharedInstance();
    self.custom = false;
    self.customMode = "None"
    // Application.sharedInstance().showHUD("process:0",Application.sharedInstance().focusWindow,5)
    self.dynamic = true;
    self.miniMode = false;
    self.shouldCopy = false
    self.shouldComment = false
    self.selectedText = '';
    self.searchedText = '';
    self.engine = 'Bing'
    self.webApp = "Bilibili"
    self.isLoading = false;
    self.toolbarOn = true;
    self.view.frame = {x:50,y:50,width:(self.appInstance.osType !== 1) ? 419 : 365,height:450}
    self.lastFrame = self.view.frame;
    self.currentFrame = self.view.frame
    self.isMainWindow = true
    self.title = "main"
    self.test = [0]
    self.moveDate = Date.now()
    self.color = [true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true]
    self.view.layer.shadowOffset = {width: 0, height: 0};
    self.view.layer.shadowRadius = 15;
    self.view.layer.shadowOpacity = 0.5;
    self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    self.view.layer.cornerRadius = 11
    self.view.layer.opacity = 1.0
    self.view.layer.borderColor = hexColorAlpha("#9bb2d6",0.8)
    self.view.layer.borderWidth = 0

    // >>> DeepL view >>>
    self.webview = new UIWebView(self.view.bounds);
    // NSUserDefaults.standardUserDefaults().setObjectForKey('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15',"UserAgent")

    //  Application.sharedInstance().showHUD("error", self.view.window, 2);
    self.webview.url = self.homePageURL;
    self.webview.backgroundColor = UIColor.whiteColor();
    self.webview.scalesPageToFit = true;
    self.webview.autoresizingMask = (1 << 1 | 1 << 4);
    self.webview.delegate = self;
    // self.webview.setValueForKey("Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15","User-Agent")
    self.webview.scrollView.delegate = self;
    self.webview.layer.cornerRadius = 15;
    self.webview.layer.masksToBounds = true;
    self.webview.layer.borderColor = hexColorAlpha("#9bb2d6",0.8);
    self.webview.layer.borderWidth = 0
    self.highlightColor = UIColor.blendedColor( hexColorAlpha("#2c4d81",0.8),
      self.appInstance.defaultTextColor,
      0.8
    );

    self.webview.hidden = true;
    self.webview.lastOffset = 0;
    self.view.addSubview(self.webview);

    self.createButton("toolbar")
    self.toolbar.backgroundColor = hexColorAlpha("#727f94",0.)


    self.createButton("webAppButton","changeWebApp:","toolbar")
    // self.webAppButton.setTitleForState('📺', 0);
    self.webAppButton.setImageForState(self.webappImage,0)

    self.createButton("closeButton","closeButtonTapped:")
    self.closeButton.setTitleForState('✖️', 0);
    self.closeButton.titleLabel.font = UIFont.systemFontOfSize(10);

    self.createButton("maxButton","maxButtonTapped:")
    self.maxButton.setTitleForState('➕', 0);
    self.maxButton.titleLabel.font = UIFont.systemFontOfSize(10);

    self.createButton("minButton","minButtonTapped:")
    self.minButton.setTitleForState('➖', 0);
    self.minButton.titleLabel.font = UIFont.systemFontOfSize(10);

    // self.createButton("screenButton","changeScreen:","toolbar")
    self.createButton("screenButton","changeScreen:","toolbar")

    self.screenButton.setImageForState(self.screenImage,0)

    self.createButton("engineButton","changeEngine:","toolbar")
    self.engineButton.setTitleForState('Bing', 0);
    self.engineButton.titleLabel.font = UIFont.boldSystemFontOfSize(14);

    // self.createButton("webAppEntriesButton","changeWebApp:","toolbar")
    // self.webAppEntriesButton.setTitleForState('Bilibili', 0);
    // self.webAppEntriesButton.titleLabel.font = UIFont.boldSystemFontOfSize(14);

    self.createButton("homeButton","homeButtonTapped:","toolbar")
    self.homeButton.setImageForState(self.homeImage,0)

    self.createButton("searchButton","searchButtonTapped:","toolbar")
    self.searchButton.setTitleForState('🔍', 0);

    self.createButton("moveButton")

    self.createButton("goForwardButton","goForwardButtonTapped:","toolbar")
    self.goForwardButton.setImageForState(self.goforwardImage,0)

    self.createButton("goBackButton","goBackButtonTapped:","toolbar")
    self.goBackButton.setImageForState(self.gobackImage,0)
    // <<< goBack button <<<
    // >>> refresh button >>>
    self.createButton("refreshButton","refreshButtonTapped:","toolbar")
    self.refreshButton.setImageForState(self.reloadImage,0)
    // <<< refresh button <<<
    // Application.sharedInstance().showHUD("process:2",Application.sharedInstance().focusWindow,5)

    self.moveGesture = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.moveButton.addGestureRecognizer(self.moveGesture)
    self.moveGesture.view.hidden = false
    self.moveGesture.addTargetAction(self,"onMoveGesture:")

    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.screenButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    self.resizeGesture.addTargetAction(self,"onResizeGesture:")
  },
  viewWillAppear: function(animated) {
    self.webview.delegate = self;
  },
  viewWillDisappear: function(animated) {
    self.webview.stopLoading();
    self.webview.delegate = null;
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
  },
viewWillLayoutSubviews: function() {
    // Application.sharedInstance().showHUD("test", self.view.window, 2);
    // Application.sharedInstance().showHUD("process:5",Application.sharedInstance().focusWindow,5)

    if (self.miniMode) {
      // self.webview.hidden = true
      return
    }
    let buttonHeight = 25
    // self.view.frame = self.currentFrame
    var viewFrame = self.view.bounds;
    var width    = viewFrame.width
    var height   = viewFrame.height
    self.closeButton.frame = genFrame(width-18,0,18,18)
    self.maxButton.frame = genFrame(width-43,0,18,18)
    self.minButton.frame = genFrame(width-68,0,18,18)

    if (self.toolbarOn) {
      self.toolbar.frame = genFrame(1, height-25, width-2,buttonHeight)
      self.screenButton.frame = genFrame(width-42,0,40,buttonHeight)
    }else{
      self.toolbar.frame = genFrame(1,height-30,width-2,buttonHeight)
      self.screenButton.frame = genFrame(width-40,0,33,buttonHeight)
    }
    self.engineButton.frame = {x: width - 122,y: 0,width: 75,height: buttonHeight};

    if (width <= 300) {
      self.goBackButton.hidden = true
      self.goForwardButton.hidden = true
      self.refreshButton.hidden = true
      self.moveButton.frame = {x: width*0.5-75,y: 0,width: width*0.35,height: 12};
      self.homeButton.frame = {  x: 0,  y: 0,  width: 47,  height: buttonHeight,};    
      self.webAppButton.frame = {  x: 52,  y: 0,  width: 47,  height: buttonHeight,};
      if (self.toolbarOn) {
        self.searchButton.frame = {  x: width-93,  y: 0,  width: 47,  height: buttonHeight,};
      }else{
        self.searchButton.frame = {  x: width - 75,  y: 0,  width: 30,  height: buttonHeight,};
      }
    }else if (width <= 380) {
      self.moveButton.frame = {  x: width*0.5-75,  y: 0,  width: width*0.35,  height: 12,};
      self.refreshButton.hidden = !self.toolbarOn
      self.goBackButton.hidden = !self.toolbarOn
      self.homeButton.hidden = !self.toolbarOn
      self.goForwardButton.hidden = !self.toolbarOn
      // self.webAppEntriesButton.hidden = true
      self.engineButton.hidden = true
      self.homeButton.frame = {  x: 106,  y: 0,  width: 47,  height: buttonHeight,};  
      self.webAppButton.frame = {  x: 157,  y: 0,  width: 47,  height: buttonHeight,};
      if (self.toolbarOn) {
        self.searchButton.frame = {  x: width-93,  y: 0,  width: 47,  height: buttonHeight,};
      }else{
        self.searchButton.frame = {  x: width - 75,  y: 0,  width: 30,  height: buttonHeight,};
      }
    }else{
      self.moveButton.frame = {  x: width*0.5-75,  y: 0,  width: 150,  height: 12,};
      self.refreshButton.hidden = !self.toolbarOn
      self.goBackButton.hidden = !self.toolbarOn
      self.goForwardButton.hidden = !self.toolbarOn
      self.engineButton.hidden = !self.toolbarOn
      // self.webAppEntriesButton.hidden = !self.toolbarOn
      self.screenButton.hidden = false
      self.homeButton.frame = {  x: 106,  y: 0,  width:47,  height: buttonHeight,};   
      self.webAppButton.frame = {  x: 157,  y: 0,  width: 47,  height: buttonHeight,};
      if (self.toolbarOn) {
        self.searchButton.frame = {  x: width - 174,  y: 0,  width: 47,  height: buttonHeight};
      }else{
        self.searchButton.frame = {  x: width - 75,  y: 0,  width: 30,  height: buttonHeight};
      }
      // self.webAppEntriesButton.frame = {  x: width - 232,  y: 0,  width: 60,  height: buttonHeight,};  
    }

    self.goBackButton.frame = {  x:1,  y: 0,  width: 30,  height: buttonHeight,};
    self.goForwardButton.frame = {  x:36,  y: 0,  width: 30,  height: buttonHeight,};
    self.refreshButton.frame = {  x: 71,  y: 0,  width: 30,  height: buttonHeight,};
    if (self.toolbarOn) {
      self.webview.frame = {x:1,y:6,width:width-2,height:height-36}
    }else{
      self.webview.frame = {x:1,y:6,width:width-2,height:height-6}
    }
    // showHUD("test")
    // self.settingController.view.frame = self.webview.frame
    self.settingViewLayout()
    self.refreshLayout()
    // Application.sharedInstance().showHUD("process:6",Application.sharedInstance().focusWindow,5)

  },

  webViewDidStartLoad: function(webView) {

    // let requestFromHomepage = self.webview.url === "https://m.inftab.com/"
    let currentURL = webView.request.URL().absoluteString();
    if (!currentURL) {return}
    self.refreshButton.setImageForState(self.stopImage,0)
    self.changeButtonOpacity(0.5)
    if (/(notion.so)|(craft.do)/.test(currentURL)) {
      webView.url = currentURL
      self.refreshButton.setImageForState(self.reloadImage,0)
      self.changeButtonOpacity(1.0)
      return;
    }
    // var pasteBoard = UIPasteboard.generalPasteboard()
    // pasteBoard.string = currentURL
    if (/^https:\/\/www.thesaurus.com/.test(currentURL)) {
      // Application.sharedInstance().showHUD("123", self.view.window, 5);
        self.updateThesaurusOffset()
      
    }
    // var pasteBoard = UIPasteboard.generalPasteboard()
    // pasteBoard.string = currentURL
    UIApplication.sharedApplication().networkActivityIndicatorVisible = true;
    // self.screenButton.setTitleForState('Loading', 0);
    // self.refreshButton.setTitleForState('✖️', 0);
  },
  webViewDidFinishLoad: function(webView) {
    self.webview.url = webView.request.URL().absoluteString();
    self.refreshButton.setImageForState(self.reloadImage,0)
    self.changeButtonOpacity(1.0)
    self.isLoading = false;
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
    if (/https:\/\/www\.bilibili\.com\/.*/.test(self.webview.url)) {
    // Application.sharedInstance().showHUD(123, self.view.window, 5);
      let frame = self.view.frame
      if (frame.width < 720) {
        frame.width = 720
        self.view.frame = frame
        self.currentFrame = frame
      }
      self.updateBilibiliOffset()
      return;
    }
    // if (/https\:\/\/.*\.bing\.com\/search.*/.test(self.webview.url)) {
    //   self.engine = "Bing"
    //   self.searchButton.setTitleForState(self.entries[self.engine].symbol, 0);
    //   self.engineButton.setTitleForState(self.entries[self.engine].engine, 0);
    //   // let searchedText  = self.webview.url.match(/(?<=search\?q=).*/)[0]
    //   let searchedText  = self.webview.url.split("search?q=")[1]

    //   self.searchedText = searchedText
    // }
    // else if (/https\:\/\/.*\.baidu\.com\/s\?wd.*/.test(self.webview.url)) {
    //   self.engine = "Baidu"
    //   self.searchButton.setTitleForState(self.entries[self.engine].symbol, 0);
    //   self.engineButton.setTitleForState(self.entries[self.engine].engine, 0);
    //   // let searchedText  = self.webview.url.match(/(?<=s\?wd=).*/)[0]
    //   let searchedText  = self.webview.url.split("s?wd=")[1]

    //   self.searchedText = searchedText
    // }else if (/https\:\/\/www\.google\.com\/search.*/.test(self.webview.url)) {
    //   self.engine = "Google"
    //   self.searchButton.setTitleForState(self.entries[self.engine].symbol, 0);
    //   self.engineButton.setTitleForState(self.entries[self.engine].engine, 0);
    //   // let searchedText  = self.webview.url.match(/(?<=search\?q=).*/)[0]
    //   let searchedText  = self.webview.url.split("search?q=")[1]

    //   self.searchedText = searchedText
    // }
    if (self.webview.url === self.homePageURL) {
      return
    }
    switch (self.engine) {
      case "Deepl":
        self.updateDeeplOffset()
        return
      case "BaiduTranslate":
        self.updateBaiduOffset()
        return
      case "ResearchGate":
        self.updateRGOffset()
        return
      case "Bing":
        // self.updateBingOffset()
        return
      case "Youdao":
        self.updateYoudaoOffset()
        return
      case "Thesaurus":
        self.updateThesaurusOffset()
        return
      default:
        break;
    }
    self.shouldCopy = false
    self.shouldComment = false
  },
  webViewDidFailLoadWithError: function(webView, error) {
    // self.screenButton.setTitleForState('Screen', 0);
    self.refreshButton.setImageForState(self.reloadImage,0)
    // self.refreshButton.setTitleForState('🔄', 0);
    self.changeButtonOpacity(1.0)
    self.isLoading = false;
    // self.getCurrentURL()
    //UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
    //var lan = NSLocale.preferredLanguages() ? NSLocale.preferredLanguages()[0].substring(0,2) : 'en';
    //if (lan == 'zh') {
    //  Application.sharedInstance().showHUD('错误', self.view.window, 2);
    //} else {
    //  Application.sharedInstance().showHUD('Failed to load DeepL translator, please try again later', self.view.window, 2);
    //}
  },
  webViewShouldStartLoadWithRequestNavigationType: function(webView,request,type){
    let currentURL = webView.request.URL().absoluteString()
    let requestURL = request.URL().absoluteString()
    // Application.sharedInstance().showHUD(requestURL, self.view.window, 2);
    if (/^https:\/\/d.bilibili/.test(requestURL)) {
      return false
    }
    if (/^marginnote3app/.test(requestURL)) {
      Application.sharedInstance().openURL(NSURL.URLWithString(requestURL));
      return false
    }
    if (shouldPrevent(currentURL,requestURL,type)) {
      // Application.sharedInstance().showHUD("prevent", self.view.window, 2);
      self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(requestURL))); 
      return false
    }
    return true;
  },
  changeScreen: function(sender) {
    if (sender.link) {
      self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(sender.link))); 
      return
    }
    // if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();

    menuController.commandTable = [
      {title:'🌗 Left',object:self,selector:'splitScreen:',param:'left',checked:self.customMode==="left"},
      {title:'🌘 Left 1/3',object:self,selector:'splitScreen:',param:'left13',checked:self.customMode==="left13"},
      {title:'🌓 Right',object:self,selector:'splitScreen:',param:'right',checked:self.customMode==="right"},
      {title:'🌒 Right 1/3',object:self,selector:'splitScreen:',param:'right13',checked:self.customMode==="right13"},
      {title:'🌟 Dynamic',object:self,selector:'dynamicButtonTapped:',param:'right',checked:self.dynamic},
      {title:'🌟 Toolbar',object:self,selector:'toggleToolbar:',param:'right',checked:self.toolbarOn},
      {title:'💥 Bigbang',object:self,selector:'bigbang:',param:'right'},
      {title:'🌐 Open in new window',object:self,selector:'openInNewWindow:',param:self.webview.url},
      {title:'🌐 Open new window',object:self,selector:'openNewWindow:',param:self.homePageURL},
      {title:'🌐 Open in browser',object:self,selector:'openInBrowser:',param:'right'},
      {title:'🌐 Copy current URL',object:self,selector:'copyCurrentURL:',param:'right'},
      {title:'🌐 Copy as MD link',object:self,selector:'copyCurrentURLWithText:',param:'right'},
      {title:'🌐 Open copied URL',object:self,selector:'openCopiedURL:',param:'right'},
      {title:'🎛 Setting',object:self,selector:'openSettingView:',param:'right'},
      {title:'🫧 Opacity',object:self,selector:'changeOpacity:',param:sender},
      {title:'🎬 Screenshot',object:self,selector:'screenshot:',param:self.view.frame.width>1000?self.view.frame.width:1000},

    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 250,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeEngine: function(sender) {
        // Application.sharedInstance().showHUD(self.entrieNames,self.view.window,2)

    // if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    var commandTable = self.entrieNames.map(entrieName => {
      return {title:self.entries[entrieName].title,object:self,selector:'searchWithEngine:',param:entrieName,checked:self.engine===entrieName}
    }).concat(
      {title:'🖥️ Desktop mode',object:self,selector:'toggleDesktop:',param:"engine", checked:self.entries[self.engine].desktop}
    )
    menuController.commandTable = commandTable
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 200,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeWebApp: function(sender) {

        // Application.sharedInstance().showHUD(self.webApp,self.view.window,2)

    // if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    var commandTable = self.webAppEntrieNames.map(entrieName => {
      return {title:self.webAppEntries[entrieName].title,object:self,selector:'changeWebAppTo:',param:entrieName,checked:self.webApp === entrieName}
    })
    .concat([
      {title:'🖥️ Desktop mode',object:self,selector:'toggleDesktop:',param:"webApp", checked:self.webAppEntries[self.webApp].desktop},
      {title:'➕ Add this page',object:self,selector:'addPageToWebApp:',param:'123'}
    ])
    menuController.commandTable = commandTable
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 200,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacity: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    menuController.commandTable = [
      {title:'100%',object:self,selector:'changeOpacityTo:',param:1.0},
      {title:'90%',object:self,selector:'changeOpacityTo:',param:0.9},
      {title:'80%',object:self,selector:'changeOpacityTo:',param:0.8},
      {title:'70%',object:self,selector:'changeOpacityTo:',param:0.7},
      {title:'60%',object:self,selector:'changeOpacityTo:',param:0.6},
      {title:'50%',object:self,selector:'changeOpacityTo:',param:0.5}
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 100,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeSearchOrder: function(sender) {
    // if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();

    menuController.commandTable = [
      {title:'Title → Excerpt → Comment',object:self,selector:'setSearchOrder:',param:[1,2,3],checked:self.searchOrder===[1,2,3]},
      {title:'Title → Comment → Excerpt',object:self,selector:'setSearchOrder:',param:[1,3,2],checked:self.searchOrder===[1,3,2]},
      {title:'Excerpt → Title → Comment',object:self,selector:'setSearchOrder:',param:[2,1,3],checked:self.searchOrder===[2,1,3]},
      {title:'Excerpt → Comment → Title',object:self,selector:'setSearchOrder:',param:[2,3,1],checked:self.searchOrder===[2,3,1]},
      {title:'Comment → Title → Excerpt',object:self,selector:'setSearchOrder:',param:[3,1,2],checked:self.searchOrder===[3,1,2]},
      {title:'Comment → Excerpt → Title',object:self,selector:'setSearchOrder:',param:[3,2,1],checked:self.searchOrder===[3,2,1]},
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 300,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  setSearchOrder:function (order) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.searchOrder = order
    // self.appInstance.showHUD("Order: "+getOrderText(self.searchOrder),self.view.window,2)
    self.orderButton.setTitleForState(getOrderText(self.searchOrder),0)
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.searchOrder,'MNBrowser_searchOrder');

  },
  onNewExcerpt: function(sender) {
    // if (params.action) {
    //   if (params.action === "toggle auto appear") {
    //     // self.view.popoverController.dismissPopoverAnimated(true);
    //     self.appearOnNewExcerpt = !self.appearOnNewExcerpt
    //   }
    //   if (params.action === "toggle auto dynamic") {
    //     self.autoDynamic = !self.autoDynamic
    //   }
    // }
    // if (params.color) {
    //   self.processNewExcerptColor = params.color
    // }
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    menuController.commandTable = [
      {title:'🌟 Auto appear',      object:self,selector:'ConfigOnNewExcerpt:',param:{action:"toggle auto appear"}, checked:self.appearOnNewExcerpt},
      {title:'🌟 Auto dynamic',     object:self,selector:'ConfigOnNewExcerpt:',param:{action:"toggle auto dynamic"},checked:self.autoDynamic},
      {title:'🌟 Auto copy',        object:self,selector:'ConfigOnNewExcerpt:',param:{action:"toggle auto copy"},   checked:self.autoCopy},
      {title:'🌟 Auto comment',     object:self,selector:'ConfigOnNewExcerpt:',param:{action:"toggle auto comment"},checked:self.autoComment},
      {title:'🌟 For all color',    object:self,selector:'ConfigOnNewExcerpt:',param:{color:-1},checked:self.processNewExcerptColor === -1},
      {title:'🌟 Light yellow only',object:self,selector:'ConfigOnNewExcerpt:',param:{color:0}, checked:self.processNewExcerptColor === 0},
      {title:'🌟 Light green only', object:self,selector:'ConfigOnNewExcerpt:',param:{color:1}, checked:self.processNewExcerptColor === 1},
      {title:'🌟 Light blue only',  object:self,selector:'ConfigOnNewExcerpt:',param:{color:2}, checked:self.processNewExcerptColor === 2},
      {title:'🌟 Pink only',        object:self,selector:'ConfigOnNewExcerpt:',param:{color:3}, checked:self.processNewExcerptColor === 3},
      {title:'🌟 Yellow only',      object:self,selector:'ConfigOnNewExcerpt:',param:{color:4}, checked:self.processNewExcerptColor === 4},
      {title:'🌟 Green only',       object:self,selector:'ConfigOnNewExcerpt:',param:{color:5}, checked:self.processNewExcerptColor === 5},
      {title:'🌟 Blue only',        object:self,selector:'ConfigOnNewExcerpt:',param:{color:6}, checked:self.processNewExcerptColor === 6},
      {title:'🌟 Red only',         object:self,selector:'ConfigOnNewExcerpt:',param:{color:7}, checked:self.processNewExcerptColor === 7},
      {title:'🌟 Orange only',      object:self,selector:'ConfigOnNewExcerpt:',param:{color:8}, checked:self.processNewExcerptColor === 8},
      {title:'🌟 Dark green only',  object:self,selector:'ConfigOnNewExcerpt:',param:{color:9}, checked:self.processNewExcerptColor === 9},
      {title:'🌟 Dark blue only',   object:self,selector:'ConfigOnNewExcerpt:',param:{color:10},checked:self.processNewExcerptColor === 10},
      {title:'🌟 Dark red only',    object:self,selector:'ConfigOnNewExcerpt:',param:{color:11},checked:self.processNewExcerptColor === 11},
      {title:'🌟 White only',       object:self,selector:'ConfigOnNewExcerpt:',param:{color:12},checked:self.processNewExcerptColor === 12},
      {title:'🌟 Light grey only',  object:self,selector:'ConfigOnNewExcerpt:',param:{color:13},checked:self.processNewExcerptColor === 13},
      {title:'🌟 Grey only',        object:self,selector:'ConfigOnNewExcerpt:',param:{color:14},checked:self.processNewExcerptColor === 14},
      {title:'🌟 Purple only',      object:self,selector:'ConfigOnNewExcerpt:',param:{color:15},checked:self.processNewExcerptColor === 15}
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 220,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacityTo:function (opacity) {
    self.view.layer.opacity = opacity
    // self.webAppButton.setTitleForState(`${opacity*100}%`, 0);
    
  },
  openSettingView:function () {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    // self.settingController.view.hidden = false
    if (!self.settingView) {
      self.createSettingView()
    }else{
    }
      self.settingView.hidden = false
    // self.settingViewLayout()
    // UIPasteboard.generalPasteboard().string = JSON.stringify(self.webAppEntries)
    
    try {
      if (self.configMode === 0) {
        self.setButtonText(self.entrieNames,self.engine)
        self.setTextview(self.engine)

      }else{
        self.setButtonText(self.webAppEntrieNames,self.webApp)
        self.setTextview(self.webApp)
      }
    } catch (error) {
      showHUD(error,self.view.window,2)
      
    }




    // self.view.addSubview(self.tabView)
  },
  toggleToolbar:function (opacity) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
    // Application.sharedInstance().showHUD(self.toolbarOn,self.view.window,2)
    self.toolbarOn = !self.toolbarOn
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.toolbarOn, 'MNBrowser_toolbar');
    self.webAppButton.hidden = !self.toolbarOn
    // self.searchButton.hidden = !self.toolbarOn
    self.homeButton.hidden = !self.toolbarOn
    self.goBackButton.hidden = !self.toolbarOn
    self.goForwardButton.hidden = !self.toolbarOn
    self.refreshButton.hidden = !self.toolbarOn
    // self.webAppEntriesButton.hidden = !self.toolbarOn

    // self.screenButton.hidden = !self.toolbarOn
    self.engineButton.hidden = !self.toolbarOn
    var viewFrame = self.view.bounds;
    UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
      if (self.toolbarOn) {
        self.webview.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height-40}
      }else{
        self.webview.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height}
      }
    })
  },
  toggleDesktop:function (param) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
    let desktop
    switch (param) {
      case "engine":
        self.entries[self.engine].desktop = !self.entries[self.engine].desktop
        desktop = self.entries[self.engine].desktop;
        NSUserDefaults.standardUserDefaults().setObjectForKey(self.entries,"MNBrowser_entries")
        break;
      case "webApp":
        self.webAppEntries[self.webApp].desktop = !self.webAppEntries[self.webApp].desktop
        desktop = self.webAppEntries[self.webApp].desktop;
        NSUserDefaults.standardUserDefaults().setObjectForKey(self.webAppEntries,"MNBrowser_webAppEntries")
    // Application.sharedInstance().showHUD(desktop,self.view.window,2)
        break;
      default:
        break;
    }
    if (desktop) {
      self.webview.customUserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.0 Safari/605.1.15'
      if (param === "engine" && self.engine === "Baidu") {
        let newURL = self.webview.url.replace("m.baidu","www.baidu")
        self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(newURL))); 
        return;
      }
    }else{
    // Application.sharedInstance().showHUD("mobile",self.view.window,2)
      self.webview.customUserAgent = 'Mozilla/5.0 (iPhone; CPU iPhone OS 15_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'
      
      if (param === "engine" && self.engine === "Baidu") {
        let newURL = self.webview.url.replace("www.baidu","m.baidu")
        self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(newURL))); 
        return;
      }
    }

    self.webview.reload();
  },
  searchWithEngine: function (engine) {
    self.engine = engine
    NSUserDefaults.standardUserDefaults().setObjectForKey(engine, 'MNBrowser_engine');
    if (self.selectedText.length) {
      self.search(self.selectedText) 
    }else{
      self.search(self.searchedText)//用户可能只是想换个搜索引擎再次搜索
    }
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
  },
  openInNewWindow: function (url) {
    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('newWindow', self.view.window, {url:url,desktop:self.entries[self.engine].desktop,engine:self.engine,webApp:self.webApp})
    self.homePage();
  },
  openNewWindow: function (url) {
    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('newWindow', self.view.window, {url:self.homePageURL,desktop:self.entries[self.engine].desktop,engine:self.engine,webApp:self.webApp})
  },
  openInBrowser: function (engine) {
  self.webview.evaluateJavaScript(
    `window.location.href`,
    (ret) => {
      self.webview.url = ret
      Application.sharedInstance().openURL(NSURL.URLWithString(self.webview.url));
    }
  );
  },
  copyCurrentURL: async function (engine) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    let url = await self.getCurrentURL()
    UIPasteboard.generalPasteboard().string = url
    Application.sharedInstance().showHUD("链接已复制",self.view.window,2)
    // Application.sharedInstance().openURL(NSURL.URLWithString(self.webview.url));
  },
  copyCurrentURLWithText: async function(){
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    let url = await self.getCurrentURL()
    let text = await self.getSelectedTextInWebview()
    // let text = await self.getTextInWebview()
    UIPasteboard.generalPasteboard().string = `[${text}](${url})`
    Application.sharedInstance().showHUD("链接已复制",self.view.window,2)
    // Application.sharedInstance().showHUD(ret,self.view.window,2)
  
  },
  bigbang: async function(){
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    let url = await self.getCurrentURL()
    // let text = await self.getSelectedTextInWebview()
    let text = await self.getTextInWebview()
    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('bigbangText', self.view.window, {text:text,url:url})

    // UIPasteboard.generalPasteboard().string = `[${text}](${url})`
    // Application.sharedInstance().showHUD("链接已复制",self.view.window,2)
    // Application.sharedInstance().showHUD(ret,self.view.window,2)
  
  },
  openCopiedURL: function (engine) {
    var pasteBoard = UIPasteboard.generalPasteboard()
    self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(pasteBoard.string)));
    // Application.sharedInstance().openURL(NSURL.URLWithString(self.webview.url));
  },
  ConfigOnNewExcerpt: function (params) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
    // Application.sharedInstance().showHUD(self.processNewExcerptColor,self.view.window,2)
    let config = {
      autoAppear: self.appearOnNewExcerpt,
      autoDynamic: self.autoDynamic,
      autoCopy:self.autoCopy,
      autoComment:self.autoComment,
      color: self.processNewExcerptColor
    }
    if (params.action) {
      if (params.action === "toggle auto appear") {
        // self.view.popoverController.dismissPopoverAnimated(true);
        self.appearOnNewExcerpt = !self.appearOnNewExcerpt
        config.autoAppear = self.appearOnNewExcerpt
      }
      if (params.action === "toggle auto dynamic") {
        self.autoDynamic = !self.autoDynamic
        config.autoDynamic = self.autoDynamic
      }
      if (params.action === "toggle auto copy") {
        self.autoCopy = !self.autoCopy
        config.autoCopy = self.autoCopy
      } 
      if (params.action === "toggle auto comment") {
        self.autoComment = !self.autoComment
        config.autoComment = self.autoComment
      }
    }
    if (params.color) {
      self.processNewExcerptColor = params.color
      config.color = self.processNewExcerptColor
    }
    NSUserDefaults.standardUserDefaults().setObjectForKey(config,"MNBrowser_onNewExcerpt")
  },
  resetConfig: function (engine) {

  let defaultEntries = {
      Bing:             { title: '🔍 Bing',           symbol: "🔍", engine: "Bing",     desktop:false, link: "https://www.bing.com/search?q=%s" },
      Baidu:            { title: '🔍 Baidu',          symbol: "🔍", engine: "Baidu",    desktop:false, link: "https://www.baidu.com/s?wd=%s" },
      Zhihu:            { title: '🔍 Zhihu',          symbol: "🔍", engine: "Zhihu",    desktop:false, link: "https://www.zhihu.com/search?type=content&q=%s" },
      Google:           { title: '🔍 Google',         symbol: "🔍", engine: "Google",   desktop:false, link: "https://www.google.com/search?q=%s" },
      Sougou:           { title: '🔍 Sougou',         symbol: "🔍", engine: "Sougou",   desktop:false, link: "https://www.sogou.com/web?query=%s" },
      Wikipedia:        { title: '🔍 Wikipedia',      symbol: "🔍", engine: "Wiki",     desktop:false, link: "https://www.wikipedia.org/w/index.php?search=%s" },
      BaiduBaike:       { title: '🔍 Baike',      symbol: "🔍", engine: "baike",    desktop:false, link: "https://baike.baidu.com/item/%s" },
      BaiduTranslate:   { title: '📔 Baidu',          symbol: "📔", engine: "Baidu",    desktop:false, link: "https://fanyi.baidu.com/#en/zh/%s" },
      Deepl:            { title: '📔 Deepl',          symbol: "📔", engine: "Deepl",    desktop:false, link: "https://www.deepl.com/translator#en/zh/%s" },
      Youdao:           { title: '📔 Youdao',         symbol: "📔", engine: "Youdao",   desktop:false, link: "https://dict.youdao.com/m/result?word=%s&lang=en" },
      GoogleTranslate:  { title: '📔 Google',         symbol: "📔", engine: "Google",   desktop:false, link: "https://translate.google.com/?sl=en&tl=zh-CN&text=%s&op=translate" },
      Korean:           { title: '📔 Korean',         symbol: "📔", engine: "Korean",   desktop:false, link: "https://korean.dict.naver.com/kozhdict/#/search?query=%s" },
      Thesaurus:        { title: '📔 Thesaurus',      symbol: "📔", engine: "Thesaurus",desktop:false, link: "https://www.thesaurus.com/browse/%s" },
      ChatGLM:          { title: '🤖 ChatGLM',        symbol: "🤖", engine: "Chat",     desktop:false, link: "https://chatglm.cn/detail?from=apply" },
      ResearchGate:     { title: '🎓 ResearchGate',   symbol: "🎓", engine: "RG",       desktop:false, link: "https://www.researchgate.net/search.Search.html?query=%s" },
      GoogleScholar:    { title: '🎓 Google Scholar', symbol: "🎓", engine: "Scholar",  desktop:false, link: "https://scholar.google.com/scholar?q=%s" }
    }
  let defaultWebAppEntries = {
      Bilibili:         { title: '📺 Bilibili',       symbol: "📺", engine: "Bilibili", desktop:true, link: "https://www.bilibili.com" },
      Notion:           { title: '📝 Notion',         symbol: "📝", engine: "Notion",   desktop:false, link: "https://www.notion.so" },
      Wolai:            { title: '📝 Wolai',          symbol: "📝", engine: "Wolai",    desktop:false, link: "https://www.wolai.com" },    
      Craft:            { title: '📝 Craft',          symbol: "📝", engine: "Craft",    desktop:false, link: "https://docs.craft.do" },
      Flomo:            { title: '📝 Flomo',          symbol: "📝", engine: "Flomo",    desktop:false, link: "https://v.flomoapp.com/mine" },
      Flowus:           { title: '📝 Flowus',         symbol: "📝", engine: "Flowus",   desktop:false, link: "https://flowus.cn" },
      Yinian:           { title: '📝 Yinian',         symbol: "📝", engine: "Yinian",   desktop:true, link: "https://www.yinian.pro/note/" },
      Baiduyun:         { title: '☁️ Baiduyun',        symbol: "☁️", engine: "Baidu",    desktop:false, link: "https://pan.baidu.com/disk/main#/index?category=all" },
    }

    // self.toolbarOn = true

    // self.webAppButton.setTitleForState(self.webAppEntries[self.webApp].symbol, 0);
    // self.webAppEntriesButton.setTitleForState(self.webAppEntries[self.webApp].engine, 0);
    if (self.configMode===0) {
      self.entries = defaultEntries
      self.entrieNames = Object.keys(self.entries)
      self.engine = self.entrieNames[0]
      self.searchButton.setTitleForState(self.entries[self.engine].symbol, 0);
      self.engineButton.setTitleForState(self.entries[self.engine].engine, 0);
      self.setButtonText(self.entrieNames,self.engine)
      self.refreshLayout()
      self.setTextview(self.engine)
      NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_entrieNames")
      NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_entries")
      NSUserDefaults.standardUserDefaults().removeObjectForKey('MNBrowser_engine');
    }else{
      // Application.sharedInstance().showHUD("default:"+Object.keys(self.defaultWebAppEntries).length+"; now:"+Object.keys(self.webAppEntries).length,self.view.window,2)
      self.webAppEntries = defaultWebAppEntries
      self.webAppEntrieNames = Object.keys(self.webAppEntries)
      self.webApp = self.webAppEntrieNames[0]
      self.setButtonText(self.webAppEntrieNames,self.webApp)
      self.refreshLayout()
      self.setTextview(self.webApp)
      NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_webAppEntrieNames")
      NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_webAppEntries")
      NSUserDefaults.standardUserDefaults().removeObjectForKey('MNBrowser_webApp');
    }
  },
  uploadConfig: function (engine) {

    let note = Database.sharedInstance().getNoteById(self.currentNoteId)
    let customEntries
    let commentsLength = note.comments.length
    if (commentsLength === 0) {
      Application.sharedInstance().showHUD("No comments found",self.view.window,2)
      return;
    }
    try {
      let comment = note.comments[0].text.replaceAll(`”`,`"`).replaceAll(`“`,`"`)
      customEntries = JSON.parse(comment)
      if (!Object.keys(customEntries).length) {
        Application.sharedInstance().showHUD("Invalid config",self.view.window,2)
        return;
      }
      // Application.sharedInstance().showHUD(Object.keys(customEntries).length,self.view.window,2)
    } catch (error) {
      Application.sharedInstance().showHUD(error,self.view.window,2)
      return;
    }
    let uploadLog = [];
    if (customEntries.Search) {
      uploadLog.push(`"Search"`)
      self.entries = customEntries.Search
      self.entrieNames = Object.keys(self.entries)
      self.engine = self.entrieNames[0]
      self.searchButton.setTitleForState(self.entries[self.engine].symbol, 0);
      self.engineButton.setTitleForState(self.entries[self.engine].engine, 0);
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.entrieNames,"MNBrowser_entrieNames")
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.entries,"MNBrowser_entries")
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.engine,'MNBrowser_engine');
    }
    if (customEntries.WebApp) {
      uploadLog.push(`"WebApp"`)
      self.webAppEntries = customEntries.WebApp
      self.webAppEntrieNames = Object.keys(self.webAppEntries)
      self.webApp = self.webAppEntrieNames[0]
      // self.webAppButton.setTitleForState(self.webAppEntries[self.webApp].symbol, 0);
      // self.webAppEntriesButton.setTitleForState(self.webAppEntries[self.webApp].engine, 0);
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.webAppEntrieNames,"MNBrowser_webAppEntrieNames")
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.webAppEntries,"MNBrowser_webAppEntries")
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.webApp,'MNBrowser_webApp');
    }
    if (uploadLog.length) {
      Application.sharedInstance().showHUD("Upload config of "+uploadLog.join(" and ")+" success!",self.view.window,2)
    }else{
      Application.sharedInstance().showHUD('Entries of "Search" or "WebApp" not found',self.view.window,2)
    }
  },
  screenshot: function (width) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.webview.takeSnapshotWithWidth(width,(snapshot)=>{
      UIPasteboard.generalPasteboard().setDataForPasteboardType(snapshot.pngData(),"public.png")
      
      self.appInstance.showHUD('截图已复制到剪贴板',self.view.window,2)
    })
  },
  homeButtonTapped: function() {
    self.homePage()
  },
  searchButtonTapped: function() {
    // try {
    //   self.view.superview.setNeedsLayout()
      
    // } catch (error) {
      
    // }
    if (self.engine === "ChatGLM" && self.webview.url === self.entries[self.engine].link) {
      let text  = decodeURIComponent(self.selectedText);
      if (!text.length) {
        let options = Object.keys(self.prompts).map(opt=>self.prompts[opt].title)
        let prompts = Object.keys(self.prompts).map(opt=>self.prompts[opt].context)
        // let option = ["请为接下来提供的每个文本生成标题","请翻译接下的提供的每个文本","请为接下来提供的每个文本提取关键词","请翻译接下来提供的每个文本并提取关键词"]
        UIAlertView.showWithTitleMessageStyleCancelButtonTitleOtherButtonTitlesTapBlock(
        "选择预设","",0,"取消",options,
        (alert, buttonIndex) => {
          if (buttonIndex>0) {
            self.runJavaScript(`if (typeof(t) !== "undefined") {
                t.value='${prompts[buttonIndex-1]}';
                t.dispatchEvent(evt)
              }else{
                let t = document.getElementsByTagName('textarea')[0];
                let evt = document.createEvent('HTMLEvents');
                evt.initEvent('input', true, true);
                t.value='${prompts[buttonIndex-1]}';
                t.dispatchEvent(evt)
              }
              setTimeout(() => {
                  document.getElementsByClassName('button-right-inner')[0].click();
                }, 200)
              `)
          }
        })
      }else{
        self.runJavaScript(`if (typeof(t) !== "undefined") {
            t.value='${text}';
            t.dispatchEvent(evt)
          }else{
            let t = document.getElementsByTagName('textarea')[0];
            let evt = document.createEvent('HTMLEvents');
            evt.initEvent('input', true, true);
            t.value='${text}';
            t.dispatchEvent(evt)
          }
          setTimeout(() => {
              document.getElementsByClassName('button-right-inner')[0].click();
            }, 200)
          `)
      }
      return;
    }
    self.search(self.selectedText)
  },
  goBackButtonTapped: function() {
    self.webview.goBack();
  },
  goForwardButtonTapped: function() {
    self.webview.goForward();
  },
  refreshButtonTapped: function(para) {

    if (self.webview.loading) {
      self.webview.stopLoading();
      self.refreshButton.setImageForState(self.reloadImage,0)
      self.changeButtonOpacity(1.0)
      self.isLoading = false;
    }else{
      self.webview.reload();
    }
  },
  dynamicButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
    // self.switchView();
    self.dynamic = true;
    self.toolbarOn = false
    self.custom = false;
    self.customMode = "None"
    self.webAppButton.hidden = true
    // self.searchButton.hidden = true
    self.homeButton.hidden = true
    self.goBackButton.hidden = true
    self.goForwardButton.hidden = true
    self.refreshButton.hidden = true
    // self.webAppEntriesButton.hidden = true

    // self.screenButton.hidden = true
    self.engineButton.hidden = true
    var viewFrame = self.view.bounds;
    self.webview.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height}
    NSUserDefaults.standardUserDefaults().setObjectForKey(true,"MNBrowser_dynamic")
    
    // self.view.frame = {x:100,y:100,width:100,height:100}
    // self.close();
  },
  closeButtonTapped: function() {
    // self.view.hidden = true;
    // self.custom = false;
    // self.dynamic = true;
    if (self.addonBar) {
      self.hide(self.addonBar.frame)
    }else{
      self.hide()
    }
    var url = 'https://m.inftab.com/'
    // var url = 'https://www.bilibili.com/online.html'
    self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(url)));
    self.searchedText = ""
  // Application.sharedInstance().showHUD(self.isMainWindow,self.view.window,2)

    if (self.isMainWindow) {
      postNotification('close',{test:123})
      // NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('close', self.view.window, {test:123})
      
    }
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.dynamic,"MNBrowser_dynamic")
  },
 closeConfigTapped: function () {
  let preOpacity = self.settingView.layer.opacity
  UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
    self.settingView.layer.opacity = 0
  },()=>{
    self.settingView.layer.opacity = preOpacity
    self.settingView.hidden = true
  })
 },
 splitScreen: function (mode) {
  if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
  self.lastFrame = self.view.frame
  // let studyFrame = self.appInstance.studyController(self.view.window).view.bounds
  // let height = studyFrame.height;
  // let width = studyFrame.width;
  // let splitLine = getSplitLine()
  // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
  // self.view.frame = {x:40,y:50,width:splitLine-40,height:height-50}
  self.custom = true;
  self.customMode = mode
  self.dynamic = false;
  self.webview.hidden = false
  self.hideAllButton()
  UIView.animateWithDurationAnimationsCompletion(0.3,()=>{
    self.setSplitScreenFrame(mode)
  },
  ()=>{
    self.showAllButton()
  })
 },
  maxButtonTapped: function() {
    if (self.customMode === "full") {
      self.customMode = "none"
      self.custom = false;
      // self.screenButton.hidden = false
      self.hideAllButton()
      UIView.animateWithDurationAnimationsCompletion(0.3,()=>{
        self.view.frame = self.lastFrame
        self.currentFrame = self.lastFrame
      },
      ()=>{
        self.showAllButton()
      
      })
      return
    }
    const frame = Application.sharedInstance().studyController(self.view.window).view.bounds
    self.lastFrame = self.view.frame
    self.customMode = "full"
    self.custom = true;
    self.dynamic = false;
    self.webview.hidden = false
    self.hideAllButton()


    UIView.animateWithDurationAnimationsCompletion(0.3,()=>{
      self.view.frame = {x:40,y:50,width:frame.width-80,height:frame.height-70}
      self.currentFrame = {x:40,y:50,width:frame.width-80,height:frame.height-70}
    },
    ()=>{
      self.showAllButton()
    })
  },
  minButtonTapped: function() {
    self.dynamic = false;
    self.miniMode = true
    let studyFrame = self.appInstance.studyController(self.view.window).view.bounds
    let studyCenter = self.appInstance.studyController(self.view.window).view.center.x

    let viewCenter = self.view.center.x
    if (viewCenter>studyCenter) {
      self.toMinimode(genFrame(studyFrame.width-40,self.view.frame.y,40,40))
    }else{
      self.toMinimode(genFrame(0,self.view.frame.y,40,40))
    }
  },
  onMoveGesture:function (gesture) {
    self.dynamic = false;
    let locationToMN = gesture.locationInView(self.appInstance.studyController(self.view.window).view)
    if (!self.miniMode && (Date.now() - self.moveDate) > 100) {
      // self.appInstance.showHUD("state:"+gesture.state, self.view.window, 2);
      let translation = gesture.translationInView(self.appInstance.studyController(self.view.window).view)
      let locationToBrowser = gesture.locationInView(self.view)
      let locationToButton = gesture.locationInView(gesture.view)
      let buttonFrame = self.moveButton.frame
      let newY = locationToButton.y-translation.y 
      let newX = locationToButton.x-translation.x
      if (gesture.state !== 3 && (newY<buttonFrame.height+5 && newY>-5 && newX<buttonFrame.width+5 && newX>-5 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20)) {
        self.locationToBrowser = {x:locationToBrowser.x-translation.x,y:locationToBrowser.y-translation.y}
        self.locationToButton = {x:newX,y:newY}
      }
      // if ((newY<buttonFrame.height && newY>0 && newX<buttonFrame.width && newX>0 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20) || !self.locationToBrowser) {

      // }
    }
    self.moveDate = Date.now()
    // let location = {x:locationToMN.x - self.locationToBrowser.x,y:locationToMN.y -self.locationToBrowser.y}
    let location = {x:locationToMN.x - self.locationToButton.x-gesture.view.frame.x,y:locationToMN.y -self.locationToButton.y-gesture.view.frame.y}


    let frame = self.view.frame
    var viewFrame = self.view.bounds;
    let studyFrame = self.appInstance.studyController(self.view.window).view.bounds
    let y = location.y
    if (y<=0) {
      y = 0
    }
    if (y>=studyFrame.height-15) {
      y = studyFrame.height-15
    }
    let x = location.x
    if (!self.miniMode) {
      if (locationToMN.x<40) {
        self.toMinimode(genFrame(0,locationToMN.y,40,40))
        return
      }
      if (locationToMN.x>studyFrame.width-40) {
        self.toMinimode(genFrame(studyFrame.width-40,locationToMN.y,40,40))
        return
      }
    }else{
      if (locationToMN.x<50) {
        self.view.frame = genFrame(0,locationToMN.y-20,40,40)
        return
      }else if (locationToMN.x>studyFrame.width-50) {
        self.view.frame = genFrame(studyFrame.width-40,locationToMN.y-20,40,40)
        return
      }else if (locationToMN.x>50) {
        let preOpacity = self.view.layer.opacity
        self.view.layer.opacity = 0
        self.hideAllButton()
        UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
          self.view.frame = genFrame(x,y,self.lastFrame.width,self.lastFrame.height)
          self.view.layer.opacity = preOpacity
          self.currentFrame = self.view.frame
        },
        ()=>{
          self.moveButton.frame = genFrame(viewFrame.x + viewFrame.width*0.5-75,viewFrame.y+5,150,10)
          self.view.layer.borderWidth = 0
          // self.view.layer.borderColor = hexColorAlpha("#9bb2d6",0.8)
          self.view.hidden = false
          self.webview.hidden = false
          self.showAllButton()
          self.toolbar.hidden = false
          if (self.toolbarOn) {
            self.homeButton.hidden = false
            self.engineButton.hidden = false
            self.webAppButton.hidden = false
            // self.webAppEntriesButton.hidden = false
          }
        })
        self.miniMode = false
        return
      }
    }
    
    if (self.custom) {
      // Application.sharedInstance().showHUD(self.custom, self.view.window, 2);
      self.customMode = "None"
      UIView.animateWithDurationAnimations(0.2,()=>{
        self.view.frame = genFrame(x,y,self.lastFrame.width,self.lastFrame.height)
        self.currentFrame  = self.view.frame
      })
    }else{
      self.view.frame = genFrame(x,y,frame.width,frame.height)
      self.currentFrame  = self.view.frame
    }
    self.custom = false;
  },
  onResizeGesture:function (gesture) {
    self.custom = false;
    self.dynamic = false;
    self.customMode = "none"
    let baseframe = gesture.view.frame
    let locationToBrowser = gesture.locationInView(self.view)
    let frame = self.view.frame
    let width = locationToBrowser.x+baseframe.width*0.5
    let height = locationToBrowser.y+baseframe.height*0.5
    if (width <= 200) {
      width = 200
    }
    if (height <= 100) {
      height = 100
    }
    //  Application.sharedInstance().showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
    //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
    self.view.frame = {x:frame.x,y:frame.y,width:width,height:height}
    self.currentFrame  = self.view.frame
  },
  changeWebAppTo:function(webApp) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    if (webApp) {
      self.webApp = webApp;
    }
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.webApp, 'MNBrowser_webApp');

    var url;
    url = self.webAppEntries[self.webApp].link
    // Application.sharedInstance().showHUD(url, self.view.window, 2);
    // self.webAppButton.setTitleForState(self.webAppEntries[self.webApp].symbol, 0);
    // self.webAppEntriesButton.setTitleForState(self.webAppEntries[self.webApp].engine, 0);
    if (self.webAppEntries[self.webApp].desktop) {
      self.webview.customUserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.0 Safari/605.1.15'
    }else{
      self.webview.customUserAgent = 'Mozilla/5.0 (iPhone; CPU iPhone OS 15_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'
    };
    if (self.webview.url !== url) {
      self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(url))); 
      self.webview.hidden = false
      return
    }
  },
  addPageToWebApp: async function (params) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
      // Application.sharedInstance().showHUD("default:"+Object.keys(self.defaultWebAppEntries).length+"; now:"+Object.keys(self.webAppEntries).length,self.view.window,2)

    let url = await self.getCurrentURL()
    let config = {title:"test",desktop:false,link:url}
    let title = await self.runJavaScript("document.title")
    // self.appInstance.showHUD(url,self.view.window,2)
    UIAlertView.showWithTitleMessageStyleCancelButtonTitleOtherButtonTitlesTapBlock(
      "Name for this page?",url,2,"Cancel",[title,"Add"],
      (alert, buttonIndex) => {
        switch (buttonIndex) {
          case 1:
            // self.appInstance.showHUD(title,self.view.window,2)
            config = {title:title,desktop:false,link:url}
            break;
          case 2:
            // self.appInstance.showHUD(alert.textFieldAtIndex(0).text,self.view.window,2)
            config = {title:alert.textFieldAtIndex(0).text,desktop:false,link:url}
            break;
          default:
            break;
        }
        let i = 0
        while (self.webAppEntries["customEWebApp"+i]) {
          i = i+1
        }
        self.webAppEntries["customEWebApp"+i] = config
        self.webAppEntrieNames = self.webAppEntrieNames.concat(("customEWebApp"+i))
        // self.setButtonText(self.webAppEntrieNames,"customEWebApp"+i)
        self.configEngine = "customEWebApp"+i
        NSUserDefaults.standardUserDefaults().setObjectForKey(self.webAppEntrieNames,"MNBrowser_webAppEntrieNames")
        NSUserDefaults.standardUserDefaults().setObjectForKey(self.webAppEntries,"MNBrowser_webAppEntries")
      // Application.sharedInstance().showHUD("default:"+Object.keys(self.defaultWebAppEntries).length+"; now:"+Object.keys(self.webAppEntries).length,self.view.window,2)

      })
  },
  advancedButtonTapped: function (params) {
    self.configView.hidden = true
    self.donationView.hidden = true
    self.advanceView.hidden = false

    self.configButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.advancedButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    self.donationButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)

  },
  donationButtonTapped: function (params) {
    self.configView.hidden = true
    self.advanceView.hidden = true
    self.donationView.hidden = false

    self.donationButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    self.configButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.advancedButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
  },
  configButtonTapped: function (params) {
    self.configView.hidden = false
    self.advanceView.hidden = true
    self.donationView.hidden = true
    self.configButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    self.advancedButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.donationButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)

  },
  configSearchTapped: function (params) {
    self.configMode = 0
    self.configEngine = self.engine
    self.configSearch.backgroundColor = hexColorAlpha("#457bd3",0.8)
    self.configWebApp.backgroundColor = hexColorAlpha("#9bb2d6",0.8);
    let entrieNames = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_entrieNames');
  
    self.setButtonText(self.entrieNames,self.engine)
    self.setTextview(self.engine)


  },
  configWebAppTapped: function (params) {
    self.configMode = 1
    self.configEngine = self.webApp
    self.configSearch.backgroundColor = hexColorAlpha("#9bb2d6",0.8);
    self.configWebApp.backgroundColor = hexColorAlpha("#457bd3",0.8)
    let webAppEntrieNames = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_webAppEntrieNames');
    self.setButtonText(self.webAppEntrieNames,self.webApp)
    self.setTextview(self.webApp)

  },
  configSaveTapped: function (params) {
    // self.appInstance.showHUD(123, self.view.window, 2);
    self.textviewInput.text = self.textviewInput.text.replaceAll(`”`,`"`)
    try {
    let config = JSON.parse(self.textviewInput.text)
    if (self.configMode === 0) {
      self.entries[self.configEngine] = config
      self.setButtonText(self.entrieNames,self.configEngine)
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.entries,"MNBrowser_entries")
    }else{
      self.webAppEntries[self.configEngine] = config
      // UIPasteboard.generalPasteboard().string = JSON.stringify(self.webAppEntries)
      self.setButtonText(self.webAppEntrieNames,self.configEngine)
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.webAppEntries,"MNBrowser_webAppEntries")
    }
    } catch (error) {
    self.appInstance.showHUD(error, self.view.window, 2);
    }

    // self.appInstance.studyController(self.view.window).focusNoteInMindMapById("FA871E6D-A175-4D1E-8568-63510CA82E42")
  },
  configAddTapped: function (params) {
    if (self.configMode === 0) {
      self.textviewInput.text = 
`{
  "title":   "🔍 new engine",
  "symbol":  "🔍",
  "engine":  "engine name",
  "desktop": false,
  "link":    "https://www.bing.com/search?q=%s"
}`
    let i = 0
    while (self.entries["customEngine"+i]) {
      i = i+1
    }
    let entries = self.entries
    entries["customEngine"+i] = JSON.parse(self.textviewInput.text)
    self.entries = entries
    self.entrieNames = self.entrieNames.concat(("customEngine"+i))
    self.setButtonText(self.entrieNames,"customEngine"+i)
    self.configEngine = "customEngine"+i
    try {
      
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.entrieNames,"MNBrowser_entrieNames")
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.entries,"MNBrowser_entries")
    entries = NSUserDefaults.standardUserDefaults().objectForKey("MNBrowser_entries")
    // self.appInstance.showHUD(Object.keys(entries),self.view.window,2)
    
    } catch (error) {
      self.appInstance.showHUD(error,self.view.window,2)
    }
    // self.setTextview(self.entrieNames,"customEngine"+i)
    }else{
      self.textviewInput.text = 
`{
  "title":   "📝 new webapp",
  "desktop": false,
  "link":    "https://www.bing.com"
}`
    let i = 0
    while (self.webAppEntries["customEWebApp"+i]) {
      i = i+1
    }
    self.webAppEntries["customEWebApp"+i] = JSON.parse(self.textviewInput.text)
    self.webAppEntrieNames = self.webAppEntrieNames.concat(("customEWebApp"+i))
    self.setButtonText(self.webAppEntrieNames,"customEWebApp"+i)
    self.configEngine = "customEWebApp"+i
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.webAppEntrieNames,"MNBrowser_webAppEntrieNames")
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.webAppEntries,"MNBrowser_webAppEntries")
    // self.setTextview(self.webAppEntrieNames,"customEWebApp"+i)

    }
  },
  configDeleteTapped: function (params) {
    if (self.configMode === 0) {
      delete self.entries[self.configEngine]
      self.entrieNames = self.entrieNames.filter(item=>item !== self.configEngine)
      if (self.configEngine === self.engine) {
        self.engine = self.entrieNames[0]
        self.configEngine = self.entrieNames[0]
        self.searchButton.setTitleForState(self.entries[self.engine].symbol, 0);
        self.engineButton.setTitleForState(self.entries[self.engine].engine, 0);
      }
    self.setButtonText(self.entrieNames,self.configEngine)
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.entrieNames,"MNBrowser_entrieNames")
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.entries,"MNBrowser_entries")
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.engine,"MNBrowser_engine")

    // self.setTextview(self.entrieNames,"customEngine"+i)
    }else{
      delete self.webAppEntries[self.configEngine]
      self.webAppEntrieNames = self.webAppEntrieNames.filter(item=>item !== self.configEngine)
      if (self.configEngine === self.webApp) {
        self.webApp = self.webAppEntrieNames[0]
        self.configEngine = self.webAppEntrieNames[0]
        // self.webAppButton.setTitleForState(self.webAppEntries[self.webApp].symbol, 0);
        // self.webAppEntriesButton.setTitleForState(self.webAppEntries[self.webApp].engine, 0);
      }
    self.setButtonText(self.webAppEntrieNames,self.configEngine)
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.webAppEntrieNames,"MNBrowser_webAppEntrieNames")
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.webAppEntries,"MNBrowser_webAppEntries")
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.webApp,"MNBrowser_webApp")

    // self.setTextview(self.webAppEntrieNames,"customEWebApp"+i)
    }

    // try {
    // let config = JSON.parse(self.textviewInput.text)
    // if (self.configMode === 0) {
    //   self.entries[self.configEngine] = config
    // }else{
    //   self.webAppEntries[self.configEngine] = config
    // }
    // } catch (error) {
    // self.appInstance.showHUD(error, self.view.window, 2);
    // }
    // self.appInstance.studyController(self.view.window).focusNoteInMindMapById("FA871E6D-A175-4D1E-8568-63510CA82E42")
  },
  configMoveUpTapped: function (params) {
    if (self.configMode === 0) {
      let index = self.entrieNames.indexOf(self.configEngine)
      if (index === 0) {
        showHUD("Already the top one!")
        return
      }
      let temp = self.entrieNames[index-1]
      self.entrieNames[index-1] = self.configEngine
      self.entrieNames[index] = temp
      self.setButtonText(self.entrieNames,self.configEngine)
      self.refreshLayout()
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.entrieNames,"MNBrowser_entrieNames")
    }else{
      let index = self.webAppEntrieNames.indexOf(self.configEngine)
      if (index === 0) {
        showHUD("Already the top one!")
        return
      }
      let temp = self.webAppEntrieNames[index-1]
      self.webAppEntrieNames[index-1] = self.configEngine
      self.webAppEntrieNames[index] = temp
      // showHUD("index:"+index)
      self.setButtonText(self.webAppEntrieNames,self.configEngine)
      self.refreshLayout()
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.webAppEntrieNames,"MNBrowser_webAppEntrieNames")

    }
  },
  configMoveDownTapped: function (params) {
    if (self.configMode === 0) {
      let index = self.entrieNames.indexOf(self.configEngine)
      if (index === self.entrieNames.length-1) {
        showHUD("Already the bottom one!")
        return
      }
      let temp = self.entrieNames[index+1]
      self.entrieNames[index+1] = self.configEngine
      self.entrieNames[index] = temp
      self.setButtonText(self.entrieNames,self.configEngine)
      self.refreshLayout()
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.entrieNames,"MNBrowser_entrieNames")
    }else{
      let index = self.webAppEntrieNames.indexOf(self.configEngine)
      if (index === self.webAppEntrieNames.length-1) {
        showHUD("Already the bottom one!")
        return
      }
      let temp = self.webAppEntrieNames[index+1]
      self.webAppEntrieNames[index+1] = self.configEngine
      self.webAppEntrieNames[index] = temp
      // showHUD("index:"+index)
      self.setButtonText(self.webAppEntrieNames,self.configEngine)
      self.refreshLayout()
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.webAppEntrieNames,"MNBrowser_webAppEntrieNames")

    }
  },
  openWebApp:function() {
    // NSUserDefaults.standardUserDefaults().synchronize();
    // let object = NSUserDefaults.standardUserDefaults().objectForKey("UserAgent");
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.webApp, 'MNBrowser_webApp');

    var url;
    url = self.webAppEntries[self.webApp].link
    // Application.sharedInstance().showHUD(url, self.view.window, 2);
    // self.webAppButton.setTitleForState(self.webAppEntries[self.webApp].symbol, 0);
    // self.webAppEntriesButton.setTitleForState(self.webAppEntries[self.webApp].engine, 0);
    if (self.webAppEntries[self.webApp].desktop) {
      self.webview.customUserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.0 Safari/605.1.15'
    }else{
      self.webview.customUserAgent = 'Mozilla/5.0 (iPhone; CPU iPhone OS 15_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'
    };
      self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(url))); 
      self.webview.hidden = false
  },
  toggleSelected:function (sender) {
    sender.isSelected = !sender.isSelected
    // self.appInstance.showHUD(text,self.view.window,2)
    let title = sender.id
    self.configEngine = title
    self.words.forEach((entryName,index)=>{
      if (entryName !== title) {
        self["nameButton"+index].isSelected = false
        self["nameButton"+index].backgroundColor = hexColorAlpha("#9bb2d6",0.8);
      }
    })
    if (sender.isSelected) {
      self.setTextview(title)
      sender.backgroundColor = hexColorAlpha("#457bd3",0.8)
    }else{
      sender.backgroundColor = hexColorAlpha("#9bb2d6",0.8);
    }
  }
});

browserController.prototype.homePage = function() {

  this.webview.customUserAgent = 'Mozilla/5.0 (iPhone; CPU iPhone OS 15_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'
  this.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(this.homePageURL)));
  this.webview.hidden = false
  this.searchedText = "";
  // this.mdxDictView.hidden = false
  // var url = `${this.webview.url}#en/${this.webview.lanCode}/${encodeURIComponent(text.replaceAll('/', '\\/'))}`;
};

browserController.prototype.search = function(text) {
  // NSUserDefaults.standardUserDefaults().synchronize();
  // let object = NSUserDefaults.standardUserDefaults().objectForKey("UserAgent");
    //  Application.sharedInstance().showHUD(text, this.view.window, 2);
try {
  

  var url;
  url = this.entries[this.engine].link.replace('%s',text)
  // Application.sharedInstance().showHUD(url, this.view.window, 2);
  this.searchButton.setTitleForState(this.entries[this.engine].symbol, 0);
  this.engineButton.setTitleForState(this.entries[this.engine].engine, 0);
  if (this.entries[this.engine].desktop) {
    this.webview.customUserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.0 Safari/605.1.15'
  }else{
    this.webview.customUserAgent = 'Mozilla/5.0 (iPhone; CPU iPhone OS 15_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'
  };
  if (this.webview.url !== url ) {
    this.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(url))); 
    this.webview.hidden = this.miniMode
    if (!this.miniMode) {
      this.showAllButton()
    }
    this.searchedText = text
    return
  }else{
    if (this.engine === "Youdao") {
      this.webview.evaluateJavaScript(`
      let containers = document.getElementsByClassName("trans-container")
      if (containers.length === 1) {
        containers[0].getElementsByClassName("trans-content")[0].textContent
      }else{
        containers[1].getElementsByClassName("basic")[0].textContent
      }
      `,(ret)=>{
    //  Application.sharedInstance().showHUD(ret, this.view.window, 2);
      
      
      })
    }

  }
} catch (error) {
     Application.sharedInstance().showHUD(error, this.view.window, 2);
  
}
};
browserController.prototype.setToolbar = async function(state) {
  this.toolbarOn = state
  this.webAppButton.hidden = !this.toolbarOn
  // this.searchButton.hidden = !this.toolbarOn
  this.homeButton.hidden = !this.toolbarOn
  this.goBackButton.hidden = !this.toolbarOn
  this.goForwardButton.hidden = !this.toolbarOn
  this.refreshButton.hidden = !this.toolbarOn
  // this.webAppEntriesButton.hidden = !this.toolbarOn
  // this.screenButton.hidden = !this.toolbarOn
  this.engineButton.hidden = !this.toolbarOn

}

browserController.prototype.updateDeeplOffset = async function() {
  if(!this.webview || !this.webview.window)return;
  // if (Application.sharedInstance().osType !== 1) {
  await this.runJavaScript(getWebJS("updateDeeplOffset"))
  // } else {
  //   this.webview.evaluateJavaScript(
  //     `document.querySelector("#gatsby-focus-wrapper > header").style.display = "none";
  //      document.querySelector("#gatsby-focus-wrapper > footer").style.display = "none";
  //      document.getElementsByClassName("TranslatorPage-module--otherSections--3cbQ7")[0].style.display = "none";`,
  //     (ret) => {}
  //   );
  // }
  let ret = await this.runJavaScript('document.getElementsByClassName("lmt__side_container--target")[0].getBoundingClientRect().top + document.body.scrollTop+document.documentElement.scrollTop;')
  if (ret && !isNaN(parseFloat(ret))) {
    this.webview.scrollView.contentOffset = {x: 0, y: parseFloat(ret) + 0};          
  } else {
    this.webview.scrollView.contentOffset = {x: 0, y: 130};          
  }
  // this.shouldCopy = false
  // this.shouldComment = false
};

browserController.prototype.updateBaiduOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.runJavaScript(`document.getElementsByClassName("new-header")[0].style.display = "none";`)
  this.shouldCopy = false
  this.shouldComment = false
};

browserController.prototype.updateBingOffset = function() {
  if(!this.webview || !this.webview.window)return;
};

browserController.prototype.updateYoudaoOffset = async function() {
  if(!this.webview || !this.webview.window)return;
  await this.runJavaScript(`document.getElementsByClassName("top-download")[0].style.display = "none";
    document.getElementsByClassName("m-top_vav")[0].style.display = "none";`)
  if (this.shouldCopy || this.shouldComment) {
    let result = await this.runJavaScript(`
    let containers = document.getElementsByClassName("trans-container")
    let explains = Array.from(document.getElementsByClassName("word-exp"))
    if (containers.length === 1) {
      containers[0].getElementsByClassName("trans-content")[0].textContent
    }else{
      explains.map(explain=>explain.textContent).join("\\n")
    }
    `)

    if (result !== NSNull.new() && this.shouldCopy) {
      UIPasteboard.generalPasteboard().string = result
    }
    if (result !== NSNull.new() && this.shouldComment) {
      undoGroupingWithRefresh(this.notebookid,()=>{
        Database.sharedInstance().getNoteById(this.currentNoteId).appendTextComment(ret)
      })
    }
    this.shouldCopy = false
    this.shouldComment = false
  }
};
browserController.prototype.updateRGOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.runJavaScript(`document.getElementsByClassName("header")[0].style.display = "none"`)
  this.shouldCopy = false
  this.shouldComment = false
};

browserController.prototype.runJavaScript = async function(script,delay) {
  if(!this.webview || !this.webview.window)return;
  return new Promise((resolve, reject) => {
    if (delay) {
      this.viewTimer = NSTimer.scheduledTimerWithTimeInterval(delay, true, () => {
        this.webview.evaluateJavaScript(script,(result) => {resolve(result)});
      })
    }else{
      this.webview.evaluateJavaScript(script,(result) => {resolve(result)});
    }
  })
};

browserController.prototype.updateBilibiliOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.runJavaScript(`document.getElementsByClassName("recommended-swipe grid-anchor")[0].style.display = "none";`,0.5)
  this.shouldCopy = false
  this.shouldComment = false
};

browserController.prototype.updateBilibiliPCOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.runJavaScript(`document.getElementById("biliMainHeader").style.display = "none";`,1)
  this.shouldCopy = false
  this.shouldComment = false
};

browserController.prototype.updateThesaurusOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.viewTimer = NSTimer.scheduledTimerWithTimeInterval(2, true, () => {
    this.runJavaScript(getWebJS("updateThesaurusOffset"))
    this.viewTimer.invalidate();
  });
  this.shouldCopy = false
  this.shouldComment = false
};

browserController.prototype.getCurrentURL = async function() {
  if(!this.webview || !this.webview.window) return;
  let url = await this.runJavaScript(`window.location.href`)
  this.webview.url = url
  return url
};
browserController.prototype.getSelectedTextInWebview = async function() {
  let ret = await this.runJavaScript(`
      function getCurrentSelect(){

      let selectionObj = null, rangeObj = null;
      let selectedText = "", selectedHtml = "";

      if(window.getSelection){
        selectionObj = window.getSelection();
        selectedText = selectionObj.toString();
      }
      return selectedText
    };
      getCurrentSelect()
    `)
  return ret
}

browserController.prototype.getTextInWebview = async function() {
  let ret = await this.runJavaScript(`
      function getSelectOrWholeText(){

      let selectionObj = null, rangeObj = null;
      let selectedText = "", selectedHtml = "";

      if(window.getSelection){
        selectionObj = window.getSelection();
        selectedText = selectionObj.toString();
        return selectedText === ""?document.body.innerText:selectedText
      }else{
        return document.body.innerText;
      }
    };
    getSelectOrWholeText()
    // document.body.innerHTML;
    `)
  // let text = getArticleContent(ret)
  // this.appInstance.showHUD(text,this.view.window,2)
  return ret
}

browserController.prototype.changeButtonOpacity = function(opacity) {
    this.toolbar.layer.opacity = opacity
    this.moveButton.layer.opacity = opacity
    this.maxButton.layer.opacity = opacity
    this.minButton.layer.opacity = opacity
    this.closeButton.layer.opacity = opacity
}
browserController.prototype.setButtonLayout = function (button,targetAction) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.whiteColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = hexColorAlpha("#9bb2d6",0.8);
    button.layer.cornerRadius = 8;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.view.addSubview(button);
}

browserController.prototype.createButton = function (buttonName,targetAction,superview) {
    this[buttonName] = UIButton.buttonWithType(0);
    this[buttonName].autoresizingMask = (1 << 0 | 1 << 3);
    this[buttonName].setTitleColorForState(UIColor.whiteColor(),0);
    this[buttonName].setTitleColorForState(this.highlightColor, 1);
    this[buttonName].backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    this[buttonName].layer.cornerRadius = 8;
    this[buttonName].layer.masksToBounds = true;
    this[buttonName].titleLabel.font = UIFont.systemFontOfSize(16);

    if (targetAction) {
      this[buttonName].addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    if (superview) {
      this[superview].addSubview(this[buttonName])
    }else{
      this.view.addSubview(this[buttonName]);
    }
}

browserController.prototype.settingViewLayout = function (){
    // showHUD("test")
    let viewFrame = this.view.bounds
    let width = viewFrame.width
    let height = viewFrame.height
    this.settingView.frame = {x:1,y:20,width:width-2,height:height-50}
    this.configView.frame = genFrame(0,40,width-2,height-60)
    this.advanceView.frame = genFrame(0,40,width-2,height-60)
    this.donationView.frame = genFrame(0,60,width-2,height-80)
    let imageWidth = Math.min(width-22,height-100)
    this.QRCode.frame = {x:10,y:10,width:imageWidth,height:imageWidth}


    this.orderButton.frame = genFrame(10,20,width-20,35)
    this.textviewInput.frame = {x:10,y:height-255,width:width-22,height:155}
    this.uploadButton.frame = {x:width-87,y:height-130,width:70,height:25}
    this.deleteButton.frame = {x:width-162,y:height-130,width:70,height:25}
    this.moveUpButton.frame = {x:width-232,y:height-130,width:30,height:25}
    this.moveDownButton.frame = {x:width-197,y:height-130,width:30,height:25}

    this.scrollview.frame = {x:10,y:50,width:width-22,height:height-310}
    this.scrollview.contentSize = {width:width-22,height:height};
    this.newEntryButton.frame = {x:width-47,y:height-290,width:30,height:25}

    let settingFrame = this.settingView.bounds
    settingFrame.x = 5
    settingFrame.y = 5
    settingFrame.height = 40
    settingFrame.width = settingFrame.width-10
    this.tabView.frame = settingFrame
    settingFrame.width = 80
    settingFrame.y = 10
    settingFrame.x = 10
    settingFrame.height = 30
    this.configButton.frame = settingFrame
    settingFrame.x = 95
    settingFrame.width = 90
    this.advancedButton.frame = settingFrame
    settingFrame.x = 190
    settingFrame.width = 90
    this.donationButton.frame = settingFrame
    settingFrame.x = width - 45
    settingFrame.width = 30
    this.closeConfig.frame = settingFrame
    settingFrame.width = 80
    settingFrame.x = 10
    settingFrame.y = 15
    this.configSearch.frame = settingFrame
    settingFrame.x = 95
    this.configWebApp.frame = settingFrame
    settingFrame.x = width-92
    this.configReset.frame = settingFrame
}

browserController.prototype.createSettingView = function (){
  this.configMode = 0
  this.configEngine = this.engine
  this.settingView = UIView.new()
  this.settingView.backgroundColor = UIColor.whiteColor().colorWithAlphaComponent(0.8)
  this.settingView.layer.cornerRadius = 13
  this.settingView.hidden = true
  this.view.addSubview(this.settingView)
  this.tabView = UIView.new()
  this.tabView.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
  this.tabView.layer.cornerRadius = 12
  this.settingView.addSubview(this.tabView)

  this.configView = UIView.new()
  this.configView.backgroundColor = hexColorAlpha("#9bb2d6",0.0)
  this.configView.layer.cornerRadius = 12
  this.settingView.addSubview(this.configView)

  this.advanceView = UIView.new()
  this.advanceView.backgroundColor = hexColorAlpha("#9bb2d6",0.0)
  this.advanceView.layer.cornerRadius = 12
  this.settingView.addSubview(this.advanceView)
  this.advanceView.hidden = true


  this.donationView = UIView.new()
  this.donationView.backgroundColor = hexColorAlpha("#9bb2d6",0.0)
  this.donationView.layer.cornerRadius = 12
  this.settingView.addSubview(this.donationView)
  this.donationView.hidden = true
  this.QRCode = UIImageView.new()
  this.QRCode.image = this.QRCodeImage
  this.donationView.addSubview(this.QRCode)


  this.createButton("configButton","configButtonTapped:","settingView")
  this.configButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.configButton.layer.opacity = 1.0
  this.configButton.setTitleForState("Config",0)

  this.createButton("advancedButton","advancedButtonTapped:","settingView")
  // this.advancedButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.advancedButton.layer.opacity = 1.0
  this.advancedButton.setTitleForState("Advanced",0)

  this.createButton("donationButton","donationButtonTapped:","settingView")
  // this.donationButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.donationButton.layer.opacity = 1.0
  this.donationButton.setTitleForState("Donation",0)

  this.createButton("closeConfig","closeConfigTapped:","settingView")
  this.closeConfig.setImageForState(this.stopImage,0)
  this.closeConfig.backgroundColor = UIColor.whiteColor().colorWithAlphaComponent(0)
  this.createButton("configSearch","configSearchTapped:","configView")
  this.configSearch.layer.opacity = 1.0
  this.configSearch.setTitleForState("Search",0)
  this.configSearch.backgroundColor = hexColorAlpha("#457bd3",0.8)

  this.createButton("configWebApp","configWebAppTapped:","configView")
  this.configWebApp.layer.opacity = 1.0
  this.configWebApp.setTitleForState("WebApp",0)

  this.createButton("configReset","resetConfig:","configView")
  this.configReset.layer.opacity = 1.0
  this.configReset.setTitleForState("Reset",0)

  this.createButton("orderButton","changeSearchOrder:","advanceView")
  this.orderButton.layer.opacity = 1.0
  this.orderButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.orderButton.setTitleForState(getOrderText(this.searchOrder),0)

  this.scrollview = UIScrollView.new()
  let viewFrame = this.view.bounds;
  this.configView.addSubview(this.scrollview)
  this.scrollview.hidden = false
  this.scrollview.delegate = this
  this.scrollview.bounces = true
  this.scrollview.alwaysBounceVertical = true
  this.scrollview.layer.cornerRadius = 8
  this.scrollview.backgroundColor = hexColorAlpha("#c0bfbf",0.8)
  this.textviewInput = UITextView.new()
  this.textviewInput.font = UIFont.systemFontOfSize(16);
  this.textviewInput.layer.cornerRadius = 8
  this.textviewInput.backgroundColor = hexColorAlpha("#c0bfbf",0.8)
  this.textviewInput.textColor = UIColor.blackColor()
  this.configView.addSubview(this.textviewInput)
  this.textviewInput.text = `Input here`
  this.textviewInput.bounces = true

  // let entries           = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_entries');
  let text  = this.entries[this.engine]
      this.textviewInput.text = `{
  "title":   "${text.title}",
  "symbol":  "${text.symbol}",
  "engine":  "${text.engine}",
  "desktop": ${text.desktop},
  "link":    "${text.link}"
}`
  this.createButton("uploadButton","configSaveTapped:","configView")
  this.uploadButton.layer.opacity = 1.0
  this.uploadButton.setTitleForState("Save",0)
  this.createButton("deleteButton","configDeleteTapped:","configView")
  this.deleteButton.layer.opacity = 1.0
  this.deleteButton.setTitleForState("Delete",0)
  this.createButton("moveUpButton","configMoveUpTapped:","configView")
  this.moveUpButton.layer.opacity = 1.0
  this.moveUpButton.setTitleForState("⬆",0)
  this.createButton("moveDownButton","configMoveDownTapped:","configView")
  this.moveDownButton.layer.opacity = 1.0
  this.moveDownButton.setTitleForState("⬇",0)
  this.createButton("newEntryButton","configAddTapped:","configView")
  this.newEntryButton.layer.opacity = 1.0
  this.newEntryButton.setTitleForState("➕",0)
}

browserController.prototype.setButtonText = function (names,highlight) {
    this.words = names
    // this.appInstance.showHUD(this.configEngine,this.view.window,5)
    // UIPasteboard.generalPasteboard().string = this.configMode

    names.map((word,index)=>{
      if (!this["nameButton"+index]) {
        this.createButton("nameButton"+index,"toggleSelected:","scrollview")
        // this["nameButton"+index].index = index
        this["nameButton"+index].titleLabel.font = UIFont.systemFontOfSize(16);
      }
      this["nameButton"+index].hidden = false
      // this["nameButton"+index].tag = 
      // if (!this.entries[word]) {
    // this.appInstance.showHUD(word+":"+Object.keys(this.webAppEntries),this.view.window,5)
        
      // }
      this["nameButton"+index].setTitleForState(this.configMode===0?this.entries[word].title:this.webAppEntries[word].title,0) 
      this["nameButton"+index].id = word

      if (word === highlight) {
        this["nameButton"+index].backgroundColor = hexColorAlpha("#457bd3",0.8)
      }else{
        this["nameButton"+index].backgroundColor = hexColorAlpha("#9bb2d6",0.8);
      }
      // this["nameButton"+index].titleEdgeInsets = {top:0,left:-100,bottom:0,right:-50}
      // this["nameButton"+index].setTitleForState(this.imagePattern[index]===this.textPattern[index]?` ${this.imagePattern[index]} `:"-1",0) 
    })
    // this.refreshLayout()
}
browserController.prototype.setTextview = function (name) {
    if (this.configMode === 0) {
      // let entries           = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_entries');
      let text  = this.entries[name]
      this.textviewInput.text = `{
  "title":   "${text.title}",
  "symbol":  "${text.symbol}",
  "engine":  "${text.engine}",
  "desktop": ${text.desktop},
  "link":    "${text.link}"
}`
    }else{
      // let entries           = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_webAppEntries');
      let text  = this.webAppEntries[name]
      this.textviewInput.text = `{
  "title":   "${text.title}",
  "desktop": ${text.desktop},
  "link":    "${text.link}"
}`
    }

}
browserController.prototype.setSplitScreenFrame = function (mode) {  
  let studyFrame = this.appInstance.studyController(this.view.window).view.bounds
  let height = studyFrame.height;
  let width = studyFrame.width;
  let splitLine = getSplitLine()
  switch (mode) {
  case "left":
    this.view.frame = genFrame(40,0,splitLine-40,height)
    break;
  case "left13":
    this.view.frame = genFrame(40,0,width/3.+40,height)
    break;
  case "right":
    this.view.frame = genFrame(splitLine,0,width-splitLine-40,height)
    break;
  case "right13":
    this.view.frame = genFrame(width*2/3.-40,0,width/3.,height)
    break;
  case "full":
    this.view.frame = genFrame(40,0,width-80,height)
    break;
  default:
    break;
  }
  this.currentFrame = this.view.frame
}
browserController.prototype.toMinimode = function (frame) {
  this.miniMode = true 
  this.dynamic = false    
  this.lastFrame = this.view.frame 
  this.webview.hidden = true
  this.currentFrame  = this.view.frame
  this.hideAllButton()
  this.view.layer.borderWidth = 3
  this.view.layer.borderColor = hexColorAlpha("#9bb2d6",0.8)
  UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
    this.view.frame = frame
    this.currentFrame  = this.view.frame
  },
  ()=>{
    this.moveButton.frame = genFrame(0,0,40,40)
    this.moveButton.hidden = false
  })
}
browserController.prototype.refreshLayout = function () {
  if (this.settingView.hidden) {
    let preOpacity = this.settingView.layer.opacity
    this.settingView.layer.opacity = 0.2
    // this.settingView.hidden = false
    this.settingView.layer.opacity = preOpacity
    var viewFrame = this.scrollview.bounds;
    var xLeft     = 0
    let initX = 10
    let initY = 10
    let initL = 0
    this.locs = [];
    this.words.map((word,index)=>{
      let title = this.configMode===0?this.entries[word].title:this.webAppEntries[word].title
      let width = strCode(title.replaceAll(" ",""))*9+15
      if (xLeft+initX+width > viewFrame.width-10) {
        initX = 10
        initY = initY+40
        initL = initL+1
      }
      this["nameButton"+index].frame = {  x: xLeft+initX,  y: initY,  width: width,  height: 30,};
      this.locs.push({
        x:xLeft+initX,
        y:initY,
        l:initL,
        i:index
      })
      initX = initX+width+10
    })
    if (this.lastLength && this.lastLength>this.words.length) {
      // Application.sharedInstance().showHUD("should clear", this.view.window, 2);
      for (let index = this.words.length; index < this.lastLength; index++) {
        this["nameButton"+index].hidden = true
      }
    }
    this.lastLength = this.words.length
    // Application.sharedInstance().showHUD(initY, this.view.window, 2);
    this.scrollview.contentSize= {width:viewFrame.width,height:initY+40}
  }else{
    var viewFrame = this.scrollview.bounds;
    var xLeft     = 0
    let initX = 10
    let initY = 10
    let initL = 0
    this.locs = [];
    this.words.map((word,index)=>{
      let title = this.configMode===0?this.entries[word].title:this.webAppEntries[word].title
      let width = strCode(title.replaceAll(" ",""))*9+15
      if (xLeft+initX+width > viewFrame.width-10) {
        initX = 10
        initY = initY+40
        initL = initL+1
      }
      this["nameButton"+index].frame = {  x: xLeft+initX,  y: initY,  width: width,  height: 30,};
      this.locs.push({
        x:xLeft+initX,
        y:initY,
        l:initL,
        i:index
      })
      initX = initX+width+10
    })
    if (this.lastLength && this.lastLength>this.words.length) {
      // Application.sharedInstance().showHUD("should clear", this.view.window, 2);
      for (let index = this.words.length; index < this.lastLength; index++) {
        this["nameButton"+index].hidden = true
      }
    }
    this.lastLength = this.words.length
    // Application.sharedInstance().showHUD(initY, this.view.window, 2);
    this.scrollview.contentSize= {width:viewFrame.width,height:initY+40}
  
  }


}

browserController.prototype.hideAllButton = function (frame) {
  this.moveButton.hidden = true
  this.closeButton.hidden = true
  this.maxButton.hidden = true
  this.minButton.hidden = true
  this.toolbar.hidden = true
}
browserController.prototype.showAllButton = function (frame) {
  this.moveButton.hidden = false
  this.closeButton.hidden = false
  this.maxButton.hidden = false
  this.minButton.hidden = false
  this.toolbar.hidden = false
}
browserController.prototype.show = function (frame) {
  let preFrame = this.view.frame
  let preOpacity = this.view.layer.opacity
  this.view.layer.opacity = 0.2
  if (frame) {
    this.view.frame = frame
    this.currentFrame = frame
  }
  this.view.hidden = false
  if (this.miniMode) {
    this.webview.layer.borderWidth = 0
  }else{
    this.webview.layer.borderWidth = 3
  }
  this.miniMode = false
  this.webview.hidden = false
  this.hideAllButton()
  if (this.toolbarOn) {
    this.engineButton.hidden = false
  }

  UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
    this.view.layer.opacity = preOpacity
    this.view.frame = preFrame
    this.currentFrame = preFrame
  },
  ()=>{
    this.webview.layer.borderWidth = 0
    this.view.layer.borderWidth = 0
    this.webview.hidden = false
    this.showAllButton()
  })
}
browserController.prototype.hide = function (frame) {
  let preFrame = this.view.frame
  let preOpacity = this.view.layer.opacity
  let preCustom = this.custom
  // let preFrame = this.view.frame
  this.webview.hidden = false
  if (this.settingView) {
    this.settingView.hidden = true
  }
  this.hideAllButton()
  this.custom = false
  if (frame) {
    this.webview.layer.borderWidth = 3
  }
  UIView.animateWithDurationAnimationsCompletion(0.25,()=>{
    this.view.layer.opacity = 0.2
    if (frame) {
      this.view.frame = frame
      this.currentFrame = frame
    }
    // this.view.frame = {x:preFrame.x+preFrame.width*0.1,y:preFrame.y+preFrame.height*0.1,width:preFrame.width*0.8,height:preFrame.height*0.8}
    // this.currentFrame = {x:preFrame.x+preFrame.width*0.1,y:preFrame.y+preFrame.height*0.1,width:preFrame.width*0.8,height:preFrame.height*0.8}
  },
  ()=>{
    this.view.hidden = true;
    this.view.layer.opacity = preOpacity      
    this.view.frame = preFrame
    this.currentFrame = preFrame
    this.webview.layer.borderWidth = 0
    this.custom = preCustom
    // this.view.frame = preFrame
    // this.currentFrame = preFrame
  })
}

	      /**
         * 摘取文章主体正文算法
         * @param body
         * @returns {正文}
         */
        let getArticleContent = function (body) {
            /**
             * 行分块的大小(块大小=BLOCKS+1)
             */
            let BLOCKS = 0;
            /**
             * 判断为正文的文字骤变率
             */
            let CHANGE_RATE = 0.9;
            /**
             * 每行最小长度
             */
            let MIN_LENGTH = 3;
 
            let html = body;
 
 
            /**
             * 去除html标签
             * @param html 请求获得的html文本
             * @return 纯文本
             */
            let deleteLabel = function (html) {
                let regEx_script = /<script\b[^<]*(?:(?!<\/script>)<[^<]*)*<\/script>/g; // 定义script的正则表达式
                let regEx_style = /<stype\b[^<]*(?:(?!<\/script>)<[^<]*)*<\/stype>/g; // 定义style的正则表达式
                let regEx_html = /<(?:.|\s)*?>/g; // 定义HTML标签的正则表达式
 
                html = html.replace(regEx_script, "");
                html = html.replace(regEx_style, "");
                html = html.replace(regEx_html, "");
                html = html.replace("((\r\n)|\n)[\\s\t ]*(\\1)+", "$1").replace("^((\r\n)|\n)", "");//去除空白行
                html = html.replace("    +| +|　+", ""); //去除空白
                return html.trim();
            };
 
            let b_html = deleteLabel(html);
 
            /**
             * 将纯文本按BLOCKS分块
             * @param text 纯文本
             * @return 分块后的map集合,键即为块号,值为块内容
             */
            let splitBlock = function (text) {
                let groupMap = new Array();
                let bais = text;
                let br = text.split('\n');
                let line = null,
                    blocksLine = "";
                let theCount = 0,
                    groupCount = 0,
                    count = 0;//1.记录每次添加的行数；2.记录块号；3.记录总行数
 
                for (let i = 0; i < br.length; i++) {
                    line = br[i];
                    if (line != '') {
                        if (line.length > MIN_LENGTH) {
                            if (theCount <= BLOCKS) {
                                blocksLine += line.trim();
                                theCount++;
                            }
                            else {
                                if (blocksLine != undefined) {
                                    groupMap[groupCount] = blocksLine;
                                    groupCount++;
                                    blocksLine = line.trim();
                                    theCount = 1;
                                }
                            }
                            count++;
                        }
                    }
 
                }
 
                if (theCount != 0 && blocksLine != undefined) {//加上没凑齐的给给定块数的
                    groupMap[groupCount + 1] = blocksLine;
                }
 
                return groupMap;
            };
 
            let o_html = splitBlock(b_html);
 
            /**
             * 分析每块之间变化的情况
             * @param map 块集合
             * @return 正文
             */
            let judgeBlocks = function (map) {
                let sets = map;
                let contentBlock = [];
                let currentBlock = map.length; //当前行的长度
                let lastBlock = 0; //上一行的长度
                for (let i = 0; i < sets.length; i++) {
                    if (sets[i] != undefined) {
                        lastBlock = currentBlock;
                        currentBlock = sets[i].length;
                        let between = Math.abs(currentBlock - lastBlock) / Math.max(currentBlock, lastBlock);
 
                        if (between >= CHANGE_RATE) {
                            contentBlock.push(i);
                        }
                    }
                }
 
                //下面是取多个峰值节点中两个节点之间内容长度最大的内容
                let matchNode = contentBlock.length;
 
                let lastContent = 0;//前一个两节点之间的内容长度
                let context = null;//结果
                if (matchNode > 2) {
                    for (let i = 1; i < matchNode; i++) {
                        let result = "";
                        for (let j = contentBlock[i - 1]; j < contentBlock[i]; j++) {
                            result += map[j];
                        }
                        if (result.length > lastContent) {
                            lastContent = result.length;
                            context += result;
                        }
 
                    }
                }
 
                return context;
            };
 
            let articleContent = judgeBlocks(o_html);
 
            return articleContent;
        }; 